/*
  SSM_Defaults.h : SiGN-SSM - Gene Network Estimation with State Sapce Model

  Copyright (C) 2010
    Yoshinori Tamada, Rui Yamaguchi, Seiya Imoto, Osamu Hirose, Ryo Yoshida,
	Masao Nagasaki and Satoru Miyano
      Laboratory of DNA Information Analysis &
	  Laboratory of Sequence Analysis, Human Genome Center,
      The Institute of Medical Science, The Unversity of Tokyo

  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU Affero General Public License as
  published by the Free Software Foundation, either version 3 of the
  License, or (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Affero General Public License for more details.

  You should have received a copy of the GNU Affero General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.

  
  Visit <http://sign.hgc.jp/signssm/> for more information.

  Written by Yoshinori Tamada <tamada at ims.u-tokyo.ac.jp>
  Originally developed by Osamu Hirose, Ryo Yoshida, Seiya Imoto, Rui Yamaguchi,
                          Tomoyuki Higuchi, and Satoru Miyano.
*/

#ifndef __SSM_DEFAULTS_H
#define __SSM_DEFAULTS_H

/*!\brief Default maximum EM loops.
 *\ingroup SiGNSSM */
#define SSM_DEFAULT_EM_LOOPS 40000

/*!\brief Default number of sets of the EM algorithm.
 *\ingroup SiGNSSM */
#define SSM_DEFAULT_SETS 1

/*!\brief Default number of iterations of the EM algorithm.
 *\ingroup SiGNSSM */
#define SSM_DEFAULT_ITERATION 100

/*!\brief Default value of the strength of contrain of F.
 *\ingroup SiGNSSM */
#define SSM_DEFAULT_CONSTRAIN_F_G 0.8

/*!\brief Default value of the random seed.
 *\ingroup SiGNSSM */
#define SSM_DEFAULT_SEED 38

#endif /* __SSM_DEFAULTS_H */

/* End of file.  Copyright (C) 2010  HGC, IMS, The University of Tokyo       */
