/*
  dispatch.h : SiGN-SSM - Gene Network Estimation with State Sapce Model

  Copyright (C) 2010
    Yoshinori Tamada, Rui Yamaguchi, Seiya Imoto, Osamu Hirose, Ryo Yoshida,
	Masao Nagasaki and Satoru Miyano
      Laboratory of DNA Information Analysis &
	  Laboratory of Sequence Analysis, Human Genome Center,
      The Institute of Medical Science, The Unversity of Tokyo

  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU Affero General Public License as
  published by the Free Software Foundation, either version 3 of the
  License, or (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Affero General Public License for more details.

  You should have received a copy of the GNU Affero General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.

  
  Visit <http://sign.hgc.jp/signssm/> for more information.

  Written by Yoshinori Tamada <tamada at ims.u-tokyo.ac.jp>
  Originally developed by Osamu Hirose, Ryo Yoshida, Seiya Imoto, Rui Yamaguchi,
                          Tomoyuki Higuchi, and Satoru Miyano.
*/

#ifndef __DISPATCH_H
#define __DISPATCH_H

#include "signssm.h"

void dispatch_jobs(Args * args);
void proc_first_dispatch(int MPI_size, int * rank_set_id,
						 int in_iter, int in_set, int in_dim,
						 int * iteration, int * set, int * dim, int * set_id);
void inc_variables(int in_iter, int in_set, int in_dim,
				   int * iteration, int * set, int * dim, int * set_id);
void calc_first_dispatch(int in_iter, int in_set, int in_dim, int rank,
						 int * dim, int * set_id);

#endif /* __DISPATCH_H */

/* End of file.  Copyright (C) 2010  HGC, IMS, The University of Tokyo       */
