/*
  Copyright (C) 2011 SiGN Project Members

  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU Affero General Public License as
  published by the Free Software Foundation, either version 3 of the
  License, or (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Affero General Public License for more details.
  
  You should have received a copy of the GNU Affero General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.

  This is a part of SiGN Library.
  Visit <http://sign.hgc.jp/> for more information.

  Written by Yoshinori Tamada <tamada at is.s.u-tokyo.ac.jp>
 */
#ifndef __SGN_OBJ_H
#define __SGN_OBJ_H

#include "SGN_Object.h"
#include "../util/SGN_Node.h"
#include "../util/SGN_Edge.h"
#include "../csml/CSMLObject.h"

#define SGN_Obj_int(x) (x->type != SGN_Type_INT ? NULL : (int *) x->ptr)
/*
inline int * SGN_Obj_int(const SGN_Object * this){
  if(this->type != SGN_Type_INT){
	return NULL;
  } else {
	return (int *) this->ptr;
  }
}
*/

#define SGN_Obj_double(x) (x->type != SGN_Type_DOUBLE ? NULL : (double *) x->ptr)
/*
inline double * SGN_Obj_double(const SGN_Object * this){
  if(this->type != SGN_Type_DOUBLE){
	return NULL;
  } else {
	return (double *) this->ptr;
  }
}
*/

#define SGN_Obj_str(x) (x->type != SGN_Type_STRING ? NULL : (char *) x->ptr)
/*
inline char * SGN_Obj_str(const SGN_Object * this){
  if(this->type != SGN_Type_STRING){
	return NULL;
  } else {
	return (char *) this->ptr;
  }
}
*/

#define SGN_Obj_Node(x) (x->type != SGN_Type_Node ? NULL : (SGN_Node *) x->ptr)
/*
inline SGN_Node * SGN_Obj_Node(const SGN_Object * this){
  if(this->type != SGN_Type_Node){
	return NULL;
  } else {
	return (SGN_Node *) this->ptr;
  }
}
*/

#define SGN_Obj_Edge(x) (x->type != SGN_Type_Edge ? NULL : (SGN_Edge *) x->ptr)
/*
inline SGN_Edge * SGN_Obj_Edge(const SGN_Object * this){
  if(this->type != SGN_Type_Edge){
	return NULL;
  } else {
	return (SGN_Edge *) this->ptr;
  }
}
*/

#define SGN_Obj_CSMLObject(x) (x->type != SGN_Type_CSMLObject ? NULL : (CSMLObject *) x->ptr) 
/*
inline CSMLObject * SGN_Obj_CSMLObject(const SGN_Object * this){
  if(this->type != SGN_Type_CSMLObject){
	return NULL;
  } else {
	return (CSMLObject *) this->ptr;
  }
}
*/

#endif /* __SGN_OBJ_H */
