#
# Makefile : SiGN-SSM - Gene Network Estimation with State Space Model
#
# Copyright (C) 2010
#    Yoshinori Tamada, Rui Yamaguchi, Seiya Imoto, Osamu Hirose, Ryo Yoshida
#    Masao Nagasaki, and Satoru Miyano
#      Laboratory of DNA Information Analysis &
#      Laboratory of Sequence Analysis, Human Genome Center,
#      The Institute of Medical Science, The Unversity of Tokyo
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
#
# Visit <http://sign.hgc.jp/signssm/> for more information.
#
# Writen by Yoshinori Tamada <tamada at ims.u-tokyo.ac.jp>
# Originally developed by Osamu Hirose, Ryo Yoshida, Seiya Imoto, Rui Yamaguchi,
#                         Tomoyuki Higuchi, and Satoru Miyano.
#

#
# For RIKEN RICC (Fujitsu fcc + SSL II on Solaris 10 SPARC64 VII)
#

INSTALLDIR=~
USE_MPI=1

CCOPT += -noansi
CCOPT += -DUSE_FUJITSU_FCC_SSL -SSL2
FCOPT += -SSL2
CCOPT += -KV9FMADD -KSPARC64VII -O5 -x- -Kvmsg
CCOPT += -Klib -Kfast -Kcfunc -Kfuse -Kpreex
CCOPT += -Kprefetch -Krdconv -Ktiling -Kunroll -Kstaticlib -Ktl_notrt
FCOPT += -KV9FMADD -KSPARC64VII -O5 -x- -Kfast -Kcfunc -Kfuse -Kpreex
FCOPT += -Kprefetch -Krdconv -Ktiling -Kunroll -Kstaticlib -Ktl_notrt

ifndef DISABLE_FORTRAN
  USE_FORTRAN = 1
endif

ifdef USE_PROFILER
  CCOPT += -Ktl_trt -Knoomitfp
endif

CC=mpifcc
MPICC=mpifcc
MPIFC=mpifrt
AR=ar
MAKE=gmake

# End of file.  Copyright (C) 2010  HGC, IMS, The University of Tokyo
