/*
  sign/math/SGN_Stat.h : Statistical Functions

  Copyright (C) 2008-2011 SiGN Project Members

  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU Affero General Public License as
  published by the Free Software Foundation, either version 3 of the
  License, or (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Affero General Public License for more details.

  You should have received a copy of the GNU Affero General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.

  This is a part of SiGN Library.
  Visit <http://sign.hgc.jp/> for more information.

  Written by Yoshinori Tamada <tamada at is.s.u-tokyo.ac.jp>
*/

#ifndef __SGN_STAT_H
#define __SGN_STAT_H

#include <stdlib.h>

double SGN_Stat_mean(double * vec, size_t n);
double SGN_Stat_variance2(double * vec, size_t n, double mean);

double SGN_Stat_runif();

double SGN_Stat_rnorm();
double SGN_Stat_qnorm(double p);
void   SGN_Stat_vqnorm(double * restrict q, 
				   const double * restrict p, const int n);
double SGN_Stat_pnorm(const double q);
double SGN_Stat_meta_analysis(const double * x, const int n);


#ifdef USE_INTEL_MKL
long int random(void);
void srandom(unsigned int seed);
#endif

#endif /* __SGN_STAT_H */

/* End of file.  Copyright (C) 2008-2011 SiGN Project Members */
