/*
  sign/signcom.c : SiGN Lib - Gene Network Estimation Library

  Copyright (C) 2008-2014 SiGN Project Members.

  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU Affero General Public License as
  published by the Free Software Foundation, either version 3 of the
  License, or (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Affero General Public License for more details.

  You should have received a copy of the GNU Affero General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.

  This is a part of SiGN Library.
  Visit <http://sign.hgc.jp/> for more information.

  Written by Yoshinori Tamada <tamada at is.s.u-tokyo.ac.jp>
*/

#include "signcom.h"

FILE * SIGN_ERR = NULL;
int sign_warning_level;
int sign_debug_level;

void SGN_init(){
  SIGN_ERR = stderr;
  sign_warning_level = 1;
  sign_debug_level = 0;
}
/* sign_init() ------------------------------------------------------------- */

void SGN_print_flags(FILE * fp){
  fprintf(SIGN_ERR, "  Compile time flags:");
#ifdef DEBUG
  fprintf(fp, " DEBUG");
#endif
#ifdef USE_MPI
  fprintf(fp, " USE_MPI");
#endif
#ifdef _OPENMP
  fprintf(fp, " _OPENMP");
#endif
#ifdef BNRC_ENBUG
  fprintf(fp, " BNRC_ENBUG");
#endif
#ifdef USE_BNRC_FIXED_DEGREE
  fprintf(fp, " USE_BNRC_FIXED_DEGREE");
#endif
#ifdef USE_INTEL_MKL
  fprintf(fp, " USE_INTEL_MKL");
#endif
#ifdef USE_FUJITSU_FCC_SSL
  fprintf(fp, " USE_FUJITSU_FCC_SSL");
#endif
#ifdef USE_MACOSX_VECLIB
  fprintf(fp, " USE_MACOSX_VECLIB");
#endif
  fprintf(SIGN_ERR, "\n");
}
/* SGN_print_flags() ======================================================= */

void SGN_set_warning_level(int lv){
  sign_warning_level = lv;
}
/* SGN_set_warning_level() ================================================= */

int SGN_get_warning_level(){
  return sign_warning_level;
}
/* SGN_get_warning_level() ================================================= */

int SGN_set_debug_level(int lv){
  int r = sign_debug_level;
  sign_debug_level = lv;
  return r;
}
/* SGN_set_debug_level() =================================================== */

/* End of file.  Copyright (C) 2008-2014  SiGN Project Members */
