/*
  sign/signcom.h : SiGN Lib - Gene Network Estimation Library

  Copyright (C) 2008-2012 SiGN Project Members.

  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU Affero General Public License as
  published by the Free Software Foundation, either version 3 of the
  License, or (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Affero General Public License for more details.

  You should have received a copy of the GNU Affero General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.

  This is a part of SiGN Library.
  Visit <http://sign.hgc.jp/> for more information.

  Written by Yoshinori Tamada <tamada at is.s.u-tokyo.ac.jp>
*/

#ifndef __SIGN_COM_H
#define __SIGN_COM_H

#include <stdio.h>

#ifndef __SIGN_SSM
#include "util/SGN_Memory.h"
#endif

#ifdef __SIGN_DEBUG
#include "util/SGN_Memory.h"
#endif

extern FILE * SIGN_ERR;
extern int sign_warning_level;
extern int sign_debug_level;

#define SIGN_SIZE_T_ERROR_VALUE ((size_t) -1)
#define SIGN_MAX_DEPTH 1000

void SGN_init();
void SGN_print_flags(FILE * fp);
void SGN_set_warning_level(int lv);
int SGN_get_warning_level();
int SGN_set_debug_level(int lv);

#ifdef USE_FUJITSU_FCC_SSL
#define main(x,y) MAIN__(x,y)
#endif

#endif /* __SIGN_COM_H */

/* End of file.  Copyright (C) 2008-2012 SiGN Project Members */
