/*
  util/SGN_Color.c : Color module

  Copyright (C) 2010 SiGN Project Members

  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU Affero General Public License as
  published by the Free Software Foundation, either version 3 of the
  License, or (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Affero General Public License for more details.
  
  You should have received a copy of the GNU Affero General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.

  This is a part of SiGN Library.
  Visit <http://sign.hgc.jp/> for more information.

  Written by Yoshinori Tamada <tamada at is.s.u-tokyo.ac.jp>
 */

#ifndef __SGN_COLOR_H
#define __SGN_COLOR_H


typedef struct {
  int r;
  int g;
  int b;
  int a;
} SGN_Color;

SGN_Color * SGN_Color_new();
SGN_Color * SGN_Color_new_RGB(int r, int g, int b, int a);
void    SGN_Color_delete(void * this);
SGN_Color * SGN_Color_clone(const SGN_Color * this);
void    SGN_Color_set(SGN_Color * this, const SGN_Color * color);
void    SGN_Color_set_RGB(SGN_Color * this, int r, int g, int b, int a);
void    SGN_Color_set_HSV(SGN_Color * this, int h, int s, int v, int a);
void    SGN_Color_sprint(const SGN_Color * this, char * buff);
void    SGN_Color_fprint(const SGN_Color * this, FILE * fp);

void SGN_Color_HSV2RGB(int h, int s, int v,
				   int * r, int * g, int * b);

void SGN_Color_set_grad(const SGN_Color * c1, const SGN_Color * c2,	double r, SGN_Color * c);

#endif /* __SGN_COLOR_H */

/* End of file.  Copyright (C) 2010  SiGN Project Members */
