/*
  util/SGN_FloatArray.h : Expandable array for float values.

  Copyright (C) 2009 SiGN Project Members

  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU Affero General Public License as
  published by the Free Software Foundation, either version 3 of the
  License, or (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Affero General Public License for more details.
  
  You should have received a copy of the GNU Affero General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.

  This is a part of SiGN Library.
  Visit <http://sign.hgc.jp/> for more information.

  Written by Yoshinori Tamada <tamada at is.s.u-tokyo.ac.jp>
*/

#ifndef __SGN_FLOAT_ARRAY_H
#define __SGN_FLOAT_ARRAY_H

typedef struct {
  float * ptr;
  size_t size;
  size_t buff_size;
} SGN_FloatArray;

SGN_FloatArray * SGN_FloatArray_new();
void             SGN_FloatArray_delete(void * this);
SGN_FloatArray * SGN_FloatArray_expand(SGN_FloatArray * this, size_t length);
SGN_FloatArray * SGN_FloatArray_add(SGN_FloatArray * this, float value);
float            SGN_FloatArray_get(const SGN_FloatArray * this, size_t index);
SGN_FloatArray * SGN_FloatArray_clear(SGN_FloatArray * this);
SGN_FloatArray * SGN_FloatArray_set(SGN_FloatArray * this, size_t index, float value);
SGN_FloatArray * SGN_FloatArray_set_size(SGN_FloatArray * this, size_t size);
float *          SGN_FloatArray_ptr(SGN_FloatArray * this);
SGN_FloatArray * SGN_FloatArray_set_ar(SGN_FloatArray * this, size_t pos,
							   const SGN_FloatArray * ar, size_t size);

#endif /* __SGN_FLOAT_ARRAY_H */

/* End of file.  Copyright (C) 2009  SiGN Project Members */

