/*
  util/SGN_ObjArray.h : Array for Object module

  Copyright (C) 2010 SiGN Project Members

  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU Affero General Public License as
  published by the Free Software Foundation, either version 3 of the
  License, or (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Affero General Public License for more details.

  You should have received a copy of the GNU Affero General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.

  This is a part of SiGN Library.
  Visit <http://sign.hgc.jp/> for more information.

  Written by Yoshinori Tamada <tamada at is.s.u-tokyo.ac.jp>
 */

#ifndef __SGN_OBJ_ARRAY_H
#define __SGN_OBJ_ARRAY_H

#include "SGN_Array.h"
#include "../lang/SGN_Object.h"

typedef SGN_Array SGN_ObjArray;

SGN_ObjArray * SGN_ObjArray_new();
void           SGN_ObjArray_delete(void * this);
void           SGN_ObjArray_delete_all(void * this);
SGN_ObjArray * SGN_ObjArray_clone(const SGN_ObjArray * this);
void           SGN_ObjArray_clear(SGN_ObjArray * this);
void           SGN_ObjArray_clear_all(SGN_ObjArray * this);
size_t         SGN_ObjArray_size(const SGN_ObjArray * this);
SGN_ObjArray * SGN_ObjArray_add(SGN_ObjArray * this, SGN_Object * object);
SGN_ObjArray * SGN_ObjArray_add_copy(SGN_ObjArray * this, const SGN_Object * object);
SGN_ObjArray * SGN_ObjArray_add_type(SGN_ObjArray * this, void * pointer, SGN_Type type);
SGN_Object *   SGN_ObjArray_get(const SGN_ObjArray * this, size_t index);
SGN_Object *   SGN_ObjArray_remove(SGN_ObjArray * this, size_t index);
void           SGN_ObjArray_remove_obj(SGN_ObjArray * this, size_t index);
void           SGN_ObjArray_sort(SGN_ObjArray * this, int (*cmp)(const void *, const void *));

#endif /* __SGN_OBJ_ARRAY_H */

/* End of file.  Copyright (C) 2010  SiGN Project Members */
