/*
  sign/util/SGN_Str.h : Utility funtions for strings

  Copyright (C) 2008-2011 SiGN Project Members.

  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU Affero General Public License as
  published by the Free Software Foundation, either version 3 of the
  License, or (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Affero General Public License for more details.

  You should have received a copy of the GNU Affero General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.

  This is a part of SiGN Library.
  Visit <http://sign.hgc.jp/> for more information.

  Written by Yoshinori Tamada <tamada at is.s.u-tokyo.ac.jp>
*/

#ifndef __SGN_STR_H
#define __SGN_STR_H

#include <stdio.h>
#include "SGN_StrArray.h"
#include "../lang/SGN_Type.h"

char *         SGN_Str_substr(const char * str, size_t length);
SGN_StrArray * SGN_Str_split(const char * str, const char delim);
SGN_StrArray * SGN_Str_split2(const char * str, const char delim);
SGN_StrArray * SGN_Str_split_str(const char * str, const char * delim);
SGN_StrArray * SGN_Str_split_trim(const char * str, const char delim);
int            SGN_Str_num_tokens(const char * str, const char delim);
char *         SGN_Str_copy(const char * str);
int            SGN_Str_readline(FILE * fp, char ** buff, size_t * size);
int            SGN_Str_readline_buff(FILE * fp, char ** buff, size_t * size);
char *         SGN_Str_trim(char * str);
void           SGN_Str_trim2(const char * str, size_t * bg, size_t * ed);
char *         SGN_Str_trim_sp(char * str);
int            SGN_Str_is_num(char ch);
char *         SGN_Str_lower(char * str);
void           SGN_Str_lower2(const char * str, char * buff);
SGN_Type       SGN_Str_detect_string_double(const char * str);


#endif /* __SGN_STR_H */

/* End of file.  Copyright (C) 2008-2011 SiGN Project Members */
