/*
  sign/util/SGN_StrBuff.h : Expandable string buffer

  Copyright (C) 2008-2011 SiGN Project Members.

  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU Affero General Public License as
  published by the Free Software Foundation, either version 3 of the
  License, or (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Affero General Public License for more details.

  You should have received a copy of the GNU Affero General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.

  This is a part of SiGN Library.
  Visit <http://sign.hgc.jp/> for more information.

  Written by Yoshinori Tamada <tamada at is.s.u-tokyo.ac.jp>
*/

#ifndef __SGN_STR_BUFF_H
#define __SGN_STR_BUFF_H

/*~\brief Expandable string buffer.
 *
 *\author Yoshinori Tamada &lt;tamada at is.s.u-tokyo.ac.jp&gt;
 */
typedef struct {
#ifdef DOXY
private:
#endif /* DOXY */
  char * ptr;
  size_t size;
  size_t buff_size;
} SGN_StrBuff;

SGN_StrBuff *    SGN_StrBuff_new();
void             SGN_StrBuff_delete(void * this);
SGN_StrBuff *    SGN_StrBuff_expand(SGN_StrBuff * this, size_t length);
SGN_StrBuff *    SGN_StrBuff_add(SGN_StrBuff * this, char c);
SGN_StrBuff *    SGN_StrBuff_add_str(SGN_StrBuff * this, const char * str);
size_t           SGN_StrBuff_length(const SGN_StrBuff * this);
size_t           SGN_StrBuff_len(const SGN_StrBuff * this);
const char *     SGN_StrBuff_str(const SGN_StrBuff * this);
void             SGN_StrBuff_clear(SGN_StrBuff * this);
char *           SGN_StrBuff_gen(const SGN_StrBuff * this);

#endif /* __SGN_STR_BUFF_H */

/* End of file.  Copyright (C) 2008-2011 SiGN Project Members */
