/*
  sign/util/SGN_StrMatrix.h : Matrices module for containing strings.

  Copyright (C) 2008-2012 SiGN Project Members.

  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU Affero General Public License as
  published by the Free Software Foundation, either version 3 of the
  License, or (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Affero General Public License for more details.

  You should have received a copy of the GNU Affero General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.

  This is a part of SiGN Library.
  Visit <http://sign.hgc.jp/> for more information.

  Written by Yoshinori Tamada <tamada at is.s.u-tokyo.ac.jp>
*/

#ifndef __SGN_STR_MATRIX_H
#define __SGN_STR_MATRIX_H

#include "SGN_Array.h"
#include "SGN_StrArray.h"
#include <stdio.h>
#include <stdlib.h>

typedef SGN_Array SGN_StrMatrix;
SGN_StrMatrix * SGN_StrMatrix_new();
SGN_StrMatrix * SGN_StrMatrix_read_fp(FILE * fp);
SGN_StrMatrix * SGN_StrMatrix_read_delim_fp(FILE * fp, char delim);
SGN_StrMatrix * SGN_StrMatrix_read_file(const char * file);
void        SGN_StrMatrix_write_fp(FILE * fp, const SGN_StrMatrix * this);
SGN_StrArray *  SGN_StrMatrix_get_line(const SGN_StrMatrix * this, size_t line);
char *      SGN_StrMatrix_get(const SGN_StrMatrix * this, size_t line, size_t col);
size_t      SGN_StrMatrix_lines(const SGN_StrMatrix * this);
size_t      SGN_StrMatrix_rows(const SGN_StrMatrix * this);
void        SGN_StrMatrix_delete(SGN_StrMatrix * this);
void        SGN_StrMatrix_add_line(SGN_StrMatrix * this, SGN_StrArray * line);
SGN_StrArray *  SGN_StrMatrix_get_column(const SGN_StrMatrix * this, size_t col);
size_t      SGN_StrMatrix_cols(const SGN_StrMatrix * this, size_t row);
size_t      SGN_StrMatrix_find_line(const SGN_StrMatrix * this, const char * str);
size_t      SGN_StrMatrix_find_line_col(const SGN_StrMatrix * this, const char * str,
										size_t col);

#endif /* __SGN_STR_MATRIX_H */

/* End of file.  Copyright (C) 2008-2012 SiGN Project Members */
